// Generated by CoffeeScript 1.9.3
var log, markdown, path;

path = require('path');

markdown = require('./markdown');

log = require('./log');

module.exports = {
  createServer: function(opts) {
    var app, connect, server;
    if (opts == null) {
      opts = {};
    }
    if (opts.host == null) {
      opts.host = '0.0.0.0';
    }
    if (opts.port == null) {
      opts.port = 1987;
    }
    if (opts.staticDir == null) {
      opts.staticDir = process.cwd();
    }
    connect = require('connect');
    app = connect();
    app.use(connect.favicon());
    app.use(require('./middleware')());
    app.use(connect.logger('dev'));
    if (opts.user && opts.pass) {
      app.use(connect.basicAuth(opts.user, opts.pass));
    }
    app.use(markdown());
    app.use(connect["static"](opts.staticDir));
    app.use(connect.directory(opts.staticDir, {
      hidden: true
    }));
    server = require('http').createServer(app);
    server.setMaxListeners(100);
    server.on('listening', function() {
      var cwd, dir;
      cwd = process.cwd();
      dir = path.basename(cwd);
      return log.bebop("serving " + dir + " at http://" + opts.host + ":" + opts.port);
    });
    server.run = function(cb) {
      if (cb == null) {
        cb = function() {};
      }
      process.once('uncaughtException', function(err) {
        if (err.code === 'EADDRINUSE') {
          log.error('address in use, retrying...');
          server.close();
          opts.port++;
          return setTimeout(server.run, 1000);
        } else {
          throw err;
        }
      });
      return server.listen(opts.port, opts.host, cb);
    };
    return server;
  }
};
